#include <windows.h>
#define BUTTON1 1
#define BUTTON2 2
WNDPROC OldWndProc;
HWND      hiddenButton,button ;
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK SubClassProc(HWND, UINT,WPARAM, LPARAM);

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,LPSTR lpCmdLine, int nCmdShow)
{
WNDCLASSEX wc;
MSG msg;
wc.cbSize        = sizeof(WNDCLASSEX);
wc.style         = 0;
wc.lpfnWndProc   = WndProc;
wc.cbClsExtra    = 0;
wc.cbWndExtra    = 0;
wc.hInstance     = hInstance;
wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
wc.lpszMenuName  = NULL;
wc.lpszClassName = TEXT("myWindowClass");
wc.hIconSm       = LoadIcon(NULL, IDI_APPLICATION);
RegisterClassEx(&wc);
CreateWindowEx(WS_EX_CLIENTEDGE,TEXT("myWindowClass"),TEXT("Global Subclass"), WS_VISIBLE | WS_OVERLAPPEDWINDOW,CW_USEDEFAULT, CW_USEDEFAULT, 240, 180, NULL, NULL, hInstance, NULL);
while(GetMessage(&msg, NULL, 0, 0) > 0)
{
TranslateMessage(&msg);
DispatchMessage(&msg);
}
return msg.wParam;
}
LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam) {
switch(msg) {
case WM_CREATE:
{
HINSTANCE hInstance = (HINSTANCE)GetModuleHandle(NULL);
//create hidden button to subclass
hiddenButton = CreateWindow(TEXT("BUTTON"), TEXT("Button 1"),WS_CHILD, 10, 10, 100, 80,hwnd, (HMENU) BUTTON1, NULL, NULL);
//sub class hidden button windows procedure with address of subclass procedure and save current windows procedure address
OldWndProc =(WNDPROC)SetClassLong (hiddenButton, GCL_WNDPROC, (DWORD)SubClassProc);
//create button using hidden button class name
button = CreateWindow(TEXT("BUTTON"), TEXT("Button 1"),WS_CHILD|WS_VISIBLE, 10, 10, 100, 80,hwnd, (HMENU) BUTTON2, NULL, NULL);
break;
}
case WM_COMMAND:
break;
case WM_DESTROY:
{
//restore original GCL_WNDPROC address 
SetClassLong(hiddenButton, GCL_WNDPROC, (DWORD) OldWndProc);
PostQuitMessage(0);
return 0;
}
}
return DefWindowProc(hwnd, msg, wParam, lParam);
}
//subclass procedure
LRESULT CALLBACK SubClassProc(HWND hwnd, UINT uMsg,WPARAM wParam, LPARAM lParam)
{
switch(uMsg)
{
case WM_LBUTTONDOWN:
MessageBeep(0xFFFFFFFF);
default:
return CallWindowProc(OldWndProc,hwnd, uMsg, wParam, lParam);
}
return 0;
}